VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsTrackMouse"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Private bTracking As Boolean
Private mTrackObject As Object
Private procPrevWndFunc As Long

Private Const WM_MOUSEHOVER = &H2A1&
Private Const WM_MOUSELEAVE = &H2A3&
Private Const WM_MOUSEMOVE = &H200

Private Const TME_HOVER = &H1&
Private Const TME_LEAVE = &H2&
Private Const GWL_WNDPROC = -4

Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function TrackMouseEvent Lib "user32" (lpEventTrack As TRACKMOUSEEVENTINFO) As Long

Private Type TRACKMOUSEEVENTINFO
   cbSize As Long
   dwFlags As Long
   hwndTrack As Long
   dwHoverTime As Long
End Type

Public Event MouseOver(ByVal x As Long, ByVal y As Long)
Attribute MouseOver.VB_MemberFlags = "40"
Public Event MouseOut()
Attribute MouseOut.VB_MemberFlags = "40"

Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Private Type POINTAPI
    x As Long
    y As Long
End Type

Private pPoint As POINTAPI

Public Function MessageReceived(ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Select Case wMsg
        Case WM_MOUSELEAVE
            RaiseEvent MouseOut
        Case WM_MOUSEHOVER
            GetCursorPos pPoint
            RaiseEvent MouseOver(pPoint.x, pPoint.y)
        Case WM_MOUSEMOVE
            StartTracking
    End Select
    
    MessageReceived = CallWindowProc(procPrevWndFunc, mTrackObject.hwnd, wMsg, wParam, lParam)
    
End Function

Public Function StartTracking() As Boolean
Attribute StartTracking.VB_MemberFlags = "40"
   If mTrackObject Is Nothing Then
      StartTracking = False
   Else
      If bTracking = True Then StopTracking
      Dim hwnd As Long
      hwnd = mTrackObject.hwnd
      colTrackMouse.Add Me, "TM" & hwnd
      procPrevWndFunc = SetWindowLong(hwnd, GWL_WNDPROC, AddressOf procTrackMouse)
      Dim tme As TRACKMOUSEEVENTINFO
      With tme
         .cbSize = Len(tme)
         .dwFlags = TME_HOVER Or TME_LEAVE
         .dwHoverTime = 1
         .hwndTrack = hwnd
      End With
      TrackMouseEvent tme
      bTracking = True
   End If
End Function

Public Function StopTracking() As Boolean
Attribute StopTracking.VB_MemberFlags = "40"
   If Not mTrackObject Is Nothing Then
      Dim hwnd As Long
      hwnd = mTrackObject.hwnd
      SetWindowLong hwnd, GWL_WNDPROC, procPrevWndFunc
      On Error Resume Next
      colTrackMouse.Remove "TM" & hwnd
      bTracking = False
   End If
End Function

Property Get TrackObject() As Object
Attribute TrackObject.VB_MemberFlags = "40"
   Set TrackObject = mTrackObject
End Property

Property Set TrackObject(obj As Object)
   If obj Is Nothing Then
      StopTracking
      Set mTrackObject = Nothing
   Else
      Set mTrackObject = obj
      StartTracking
   End If
End Property

Private Sub Class_Terminate()
   Set TrackObject = Nothing
End Sub

